Template name
ACS-ECS-ConfigurePackage
Template description
Installs or uninstalls a Yellowdog Updater Modified (YUM) or Advanced Packaging Tool (APT) package on multiple Elastic Compute Service (ECS) instances at a time.
Template type
Automated
Owner
Alibaba Cloud
Input parameters
Parameter | Description | Type | Required | Default value | Limit |
action | The operation that you want to perform. | String | Yes | ||
targets | The ECS instances on which you want to install or uninstall the YUM or APT package. | Json | Yes | ||
packageName | The name of the YUM or APT package to be installed. | String | Yes | ||
regionId | The region ID. | String | No | {{ ACS::RegionId }} | |
installer | The source of the package. | String | No | apt-get | |
rateControl | The rate control settings. | Json | No | {'Mode': 'Concurrency', 'MaxErrors': '0', 'Concurrency': 10} | |
OOSAssumeRole | The Resource Access Management (RAM) role that is assumed by CloudOps Orchestration Service (OOS). | String | No | "" |
Output parameters
Parameter | Description | Type |
commandOutput | String |
Permission policy that is required to execute the template
{
"Version": "1",
"Statement": [
{
"Action": [
"ecs:DescribeInstances",
"ecs:DescribeInvocationResults",
"ecs:DescribeInvocations",
"ecs:RunCommand"
],
"Resource": "*",
"Effect": "Allow"
}
]
}
References
For more information, see ACS-ECS-ConfigurePackage.yml at GitHub.
Template content
FormatVersion: OOS-2019-06-01
Description:
en: Use this template to install or unistall package on ecs
zh-cn: the description in Chinese
name-en: ACS-ECS-ConfigurePackage
name-zh-cn: the description in Chinese
categories:
- run_command
Parameters:
regionId:
Type: String
Label:
en: RegionId
zh-cn: the description in Chinese
AssociationProperty: RegionId
Default: '{{ ACS::RegionId }}'
installer:
Type: String
Label:
en: Installer
zh-cn: the description in Chinese
Default: apt-get
AllowedValues:
- apt-get
- yum
action:
Type: String
Label:
en: Action
zh-cn: the description in Chinese
AllowedValues:
- install
- uninstall
targets:
Type: Json
Label:
en: TargetInstance
zh-cn: the description in Chinese
AssociationProperty: Targets
AssociationPropertyMetadata:
ResourceType: 'ALIYUN::ECS::Instance'
RegionId: regionId
packageName:
Type: String
Label:
en: PackageName
zh-cn: the description in Chinese
rateControl:
Label:
en: RateControl
zh-cn: the description in Chinese
Type: Json
AssociationProperty: RateControl
Default:
Mode: Concurrency
MaxErrors: 0
Concurrency: 10
OOSAssumeRole:
Label:
en: OOSAssumeRole
zh-cn: the description in Chinese
Type: String
Default: ''
RamRole: '{{ OOSAssumeRole }}'
Tasks:
- Name: getInstance
Description:
en: Views the ECS instances
zh-cn: the description in Chinese
Action: 'ACS::SelectTargets'
Properties:
ResourceType: 'ALIYUN::ECS::Instance'
RegionId: '{{ regionId }}'
Filters:
- '{{ targets }}'
Outputs:
instanceIds:
Type: List
ValueSelector: 'Instances.Instance[].InstanceId'
- Name: runCommand
Action: 'ACS::ECS::RunCommand'
Properties:
commandContent: |-
#!/bin/bash
if [ "{{installer}}" = "yum" ]; then
if [ "{{action}}" = "install" ]; then
yum install -y {{packageName}}
if [ $? -ne 0 ]; then
echo "Package is install failed. Please check your command" >&2;
exit 1;
fi
exit 0;
elif [ "{{action}}" = "uninstall" ]; then
yum remove -y {{packageName}}
if [ $? -ne 0 ]; then
echo "Package uninstall failed. Please check your command" >&2;
exit 1;
fi
exit 0;
else
echo "Package command must be install or uninstall" >& 2
exit 1;
fi
elif [ "{{installer}}" = "apt-get" ]; then
if [ "{{action}}" = "install" ]; then
apt-get -y install {{packageName}}
if [ $? -ne 0 ]; then
echo "Package is install failed. Please check your command" >&2;
exit 1;
fi
exit 0;
elif [ "{{action}}" = "uninstall" ]; then
apt-get -y remove {{packageName}}
if [ $? -ne 0 ]; then
echo "Package uninstall failed. Please check your command" >&2;
exit 1;
fi
exit 0;
else
echo "Package command must be install or uninstall" >& 2
exit 1;
fi
else
echo "Unknown pakcage installer. Only support yum/apt-get" >&2;
exit 1;
fi
instanceId: '{{ ACS::TaskLoopItem }}'
regionId: '{{ regionId }}'
commandType: RunShellScript
Loop:
Items: '{{ getInstance.instanceIds }}'
RateControl: '{{ rateControl }}'
Outputs:
commandOutputs:
AggregateType: 'Fn::ListJoin'
AggregateField: commandOutput
Outputs:
commandOutput:
Type: String
ValueSelector: invocationOutput
Outputs:
commandOutput:
Type: String
Value: '{{ runCommand.commandOutputs }}'
Metadata:
ALIYUN::OOS::Interface:
ParameterGroups:
- Parameters:
- installer
- action
- packageName
Label:
default:
zh-cn: the description in Chinese
en: Configure Parameters
- Parameters:
- regionId
- targets
Label:
default:
zh-cn: the description in Chinese
en: Select Ecs Instances
- Parameters:
- rateControl
- OOSAssumeRole
Label:
default:
zh-cn: the description in Chinese
en: Control Options